; ###########################################################################
; original source from donkey
; adapted/modified by denise_amiga

.586						; create 32 bit code
.model flat, stdcall		; 32 bit memory model
option casemap :none		; case sensitive

include	windows.inc
include kernel32.inc

.code

; ###########################################################################

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 4

sa_Del proc pArray:DWORD,iString:DWORD

_index		= 0*4											; \
_count		= 1*4											; | extra
_size		= 2*4											; | data
_reserved	= 3*4											; /
_array		= 4*4											; <- begin array

	push	ebx

	mov		ebx, [esp+2*4]									; pArray
	mov		ecx, [esp+3*4]									; iString
	mov		eax, [ebx+_size]								; size

	.if		(ecx <= 0) || (ecx > eax)						; inside limits?
		mov		eax, -1										; return -1
		jmp		@exit
	.endif

	push	ecx
	mov		eax, [ebx+ecx*4+_reserved]						; base 1, get ptr
	test	eax, eax										; ptr null?
	jz		@F

	invoke	GlobalFree, eax									; free strings
@@:
	pop		ecx

	xor		eax, eax
	mov		[ebx+ecx*4+_reserved], eax
	sub		dword ptr [ebx+_count], 1						; dec count
@exit:
	pop		ebx
	ret		2*4

sa_Del endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; ###########################################################################

end
